## simgear 3.0.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6.4)
include (CheckFunctionExists)
include (CheckIncludeFile)
include (CheckCXXSourceCompiles)
include (CheckCXXCompilerFlag)

project(SimGear)

# read 'version' file into a variable (stripping any newlines or spaces)
file(READ version versionFile)
string(STRIP ${versionFile} SIMGEAR_VERSION)

set(FIND_LIBRARY_USE_LIB64_PATHS ON)

# use simgear version also as the SO version (if building SOs)
SET(SIMGEAR_SOVERSION ${SIMGEAR_VERSION})

# Warning when build is not an out-of-source build.
string(COMPARE EQUAL "${CMAKE_SOURCE_DIR}" "${CMAKE_BINARY_DIR}" InSourceBuild)
if(InSourceBuild)
    message(WARNING  "Avoid building inside the source tree!")
    message(WARNING  "Create a separate build directory instead (i.e. 'sgbuild') and call CMake from there: ")
    message(WARNING  "  mkdir ../sgbuild && cd ../sgbuild && cmake ${CMAKE_SOURCE_DIR}")
endif(InSourceBuild)

#packaging
SET(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/COPYING")
SET(CPACK_RESOURCE_FILE_README "${PROJECT_SOURCE_DIR}/README")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Simulation support libraries for FlightGear and related projects")
SET(CPACK_PACKAGE_VENDOR "The FlightGear project")
SET(CPACK_GENERATOR "TBZ2")
SET(CPACK_INSTALL_CMAKE_PROJECTS  ${CMAKE_CURRENT_BINARY_DIR};SimGear;ALL;/)


# split version string into components, note CMAKE_MATCH_0 is the entire regexp match
string(REGEX MATCH "([0-9]+)\\.([0-9]+)\\.([0-9]+)" CPACK_PACKAGE_VERSION ${SIMGEAR_VERSION} )
set(CPACK_PACKAGE_VERSION_MAJOR ${CMAKE_MATCH_1}) 
set(CPACK_PACKAGE_VERSION_MINOR ${CMAKE_MATCH_2})
set(CPACK_PACKAGE_VERSION_PATCH ${CMAKE_MATCH_3})

message(STATUS "version is ${CPACK_PACKAGE_VERSION_MAJOR} dot ${CPACK_PACKAGE_VERSION_MINOR} dot ${CPACK_PACKAGE_VERSION_PATCH}")

set(CPACK_SOURCE_GENERATOR TBZ2)
set(CPACK_SOURCE_PACKAGE_FILE_NAME "simgear-${SIMGEAR_VERSION}" CACHE INTERNAL "tarball basename")
set(CPACK_SOURCE_IGNORE_FILES
  "^${PROJECT_SOURCE_DIR}/.git;\\\\.gitignore;Makefile.am;~$;${CPACK_SOURCE_IGNORE_FILES}")

message(STATUS "ignoring: ${CPACK_SOURCE_IGNORE_FILES}")

include (CPack)

# We have some custom .cmake scripts not in the official distribution.
set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/CMakeModules;${CMAKE_MODULE_PATH}")

# Change the default build type to something fast
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif(NOT CMAKE_BUILD_TYPE)

# Determine name of library installation directory, i.e. "lib" vs "lib64", which
# differs between all Debian-based vs all other Linux distros.
# See cmake bug #11964, http://cmake.org/gitweb?p=cmake.git;a=commit;h=126c993d
# GNUInstallDirs requires CMake >= 2.8.5, use own file for older cmake
if(${CMAKE_VERSION} VERSION_GREATER 2.8.4)
  include(GNUInstallDirs)
else(${CMAKE_VERSION} VERSION_GREATER 2.8.4)
  include(OldGNUInstallDirs)
endif(${CMAKE_VERSION} VERSION_GREATER 2.8.4)
message(STATUS "Library installation directory: ${CMAKE_INSTALL_LIBDIR}")

#####################################################################################
# Configure library search paths
#####################################################################################

if(NOT "${CMAKE_LIBRARY_ARCHITECTURE}" STREQUAL "")
    # Workaround for Ubuntu/Debian which introduced the "multiarch" library
    # directory structure, which is unsupported by CMake < 2.8.10, so we need to
    # add paths manually
    # see http://www.cmake.org/Bug/view.php?id=12049 and
    # http://www.cmake.org/Bug/view.php?id=12037
    list(APPEND ADDITIONAL_LIBRARY_PATHS
         /usr/local/lib/${CMAKE_LIBRARY_ARCHITECTURE}
         /usr/lib/${CMAKE_LIBRARY_ARCHITECTURE}
         /lib/${CMAKE_LIBRARY_ARCHITECTURE})
    message(STATUS "additional library directories: ${ADDITIONAL_LIBRARY_PATHS}")
endif()

#####################################################################################

if (NOT MSVC)
option(SIMGEAR_SHARED   "Set to ON to build SimGear as a shared library/framework" OFF)
option(SYSTEM_EXPAT     "Set to ON to build SimGear using the system libExpat" OFF)
else()
# Building SimGear DLLs is currently not supported for MSVC.
set(SIMGEAR_SHARED OFF)
# Using a system expat is currently not supported for MSVC - it would require shared simgear (DLL).
set(SYSTEM_EXPAT OFF)
endif()

option(SIMGEAR_HEADLESS "Set to ON to build SimGear without GUI/graphics support" OFF)
option(JPEG_FACTORY     "Enable JPEG-factory support" OFF)
option(ENABLE_RTI       "Set to ON to build SimGear with RTI support" OFF)
option(ENABLE_TESTS     "Set to OFF to disable building SimGear's test applications" ON)
option(ENABLE_SOUND     "Set to OFF to disable building SimGear's sound support" ON)
option(ENABLE_PKGUTIL   "Set to ON to build the sg_pkgutil application (default)" ON)

if (MSVC)
  GET_FILENAME_COMPONENT(PARENT_DIR ${PROJECT_BINARY_DIR} PATH)
  if (CMAKE_CL_64)
    SET(TEST_3RDPARTY_DIR "${PARENT_DIR}/3rdparty.x64")
  else (CMAKE_CL_64)
    SET(TEST_3RDPARTY_DIR "${PARENT_DIR}/3rdparty")
  endif (CMAKE_CL_64)
  if (EXISTS ${TEST_3RDPARTY_DIR})
    set(MSVC_3RDPARTY_ROOT ${PARENT_DIR} CACHE PATH "Location where the third-party dependencies are extracted")
  else (EXISTS ${TEST_3RDPARTY_DIR})
    set(MSVC_3RDPARTY_ROOT NOT_FOUND CACHE PATH "Location where the third-party dependencies are extracted")
  endif (EXISTS ${TEST_3RDPARTY_DIR})
else (MSVC)
  set(MSVC_3RDPARTY_ROOT NOT_FOUND CACHE PATH "Location where the third-party dependencies are extracted")
endif (MSVC)

if (MSVC AND MSVC_3RDPARTY_ROOT)
  message(STATUS "3rdparty files located in ${MSVC_3RDPARTY_ROOT}")
  set( OSG_MSVC "msvc" )
  if (${MSVC_VERSION} EQUAL 1700)
      set( OSG_MSVC ${OSG_MSVC}110 )
  elseif (${MSVC_VERSION} EQUAL 1600)
      set( OSG_MSVC ${OSG_MSVC}100 )
  else (${MSVC_VERSION} EQUAL 1700)
      set( OSG_MSVC ${OSG_MSVC}90 )
  endif (${MSVC_VERSION} EQUAL 1700)
  if (CMAKE_CL_64)
      set( OSG_MSVC ${OSG_MSVC}-64 )
      set( MSVC_3RDPARTY_DIR 3rdParty.x64 )
  else (CMAKE_CL_64)
      set( MSVC_3RDPARTY_DIR 3rdParty )
  endif (CMAKE_CL_64)

  set (CMAKE_LIBRARY_PATH ${MSVC_3RDPARTY_ROOT}/${MSVC_3RDPARTY_DIR}/lib ${MSVC_3RDPARTY_ROOT}/install/${OSG_MSVC}/OpenScenegraph/lib ${MSVC_3RDPARTY_ROOT}/install/${OSG_MSVC}/OpenRTI/lib )
  set (CMAKE_INCLUDE_PATH ${MSVC_3RDPARTY_ROOT}/${MSVC_3RDPARTY_DIR}/include ${MSVC_3RDPARTY_ROOT}/install/${OSG_MSVC}/OpenScenegraph/include ${MSVC_3RDPARTY_ROOT}/install/${OSG_MSVC}/OpenRTI/include)
  find_path(BOOST_ROOT boost/version.hpp
			${MSVC_3RDPARTY_ROOT}/boost
			${MSVC_3RDPARTY_ROOT}/boost_1_52_0
			${MSVC_3RDPARTY_ROOT}/boost_1_51_0
			${MSVC_3RDPARTY_ROOT}/boost_1_50_0
			${MSVC_3RDPARTY_ROOT}/boost_1_49_0
			${MSVC_3RDPARTY_ROOT}/boost_1_48_0
			${MSVC_3RDPARTY_ROOT}/boost_1_47_0
			${MSVC_3RDPARTY_ROOT}/boost_1_46_1
			${MSVC_3RDPARTY_ROOT}/boost_1_46_0
			${MSVC_3RDPARTY_ROOT}/boost_1_45_0
			${MSVC_3RDPARTY_ROOT}/boost_1_44_0
			)
  # set (BOOST_ROOT ${MSVC_3RDPARTY_ROOT}/boost_1_44_0)
  message(STATUS "BOOST_ROOT is ${BOOST_ROOT}")
  set (OPENAL_INCLUDE_DIR ${MSVC_3RDPARTY_ROOT}/${MSVC_3RDPARTY_DIR}/include)
  set (OPENAL_LIBRARY_DIR ${MSVC_3RDPARTY_ROOT}/${MSVC_3RDPARTY_DIR}/lib)
endif (MSVC AND MSVC_3RDPARTY_ROOT)

if(APPLE)
  find_library(CORE_SERVICES_LIBRARY CoreServices)
endif()

find_package(Boost REQUIRED)
set (BOOST_CXX_FLAGS "-DBOOST_MULTI_INDEX_DISABLE_SERIALIZATION -DBOOST_BIMAP_DISABLE_SERIALIZATION")

if(SIMGEAR_HEADLESS)
    message(STATUS "SimGear mode: HEADLESS")
    set(ENABLE_SOUND 0)
else()
    message(STATUS "SimGear mode: NORMAL")
    find_package(OpenGL REQUIRED)
    
    if (ENABLE_SOUND)
        find_package(OpenAL REQUIRED)
        message(STATUS "Sound support: ENABLED")
    endif(ENABLE_SOUND)
    
    find_package(OpenSceneGraph 3.0.0 REQUIRED osgText osgSim osgDB osgParticle osgGA osgUtil)
endif(SIMGEAR_HEADLESS)

if(JPEG_FACTORY)
    message(STATUS "JPEG-factory: ENABLED")
    find_package(JPEG REQUIRED)
    include_directories(${JPEG_INCLUDE_DIR})
else()
    message(STATUS "JPEG-factory: DISABLED")
endif(JPEG_FACTORY)

find_package(ZLIB REQUIRED)
find_package(Threads REQUIRED)

if (SYSTEM_EXPAT)
    message(STATUS "Requested to use system Expat library, forcing SIMGEAR_SHARED to true")
    set(SIMGEAR_SHARED ON)
    find_package(EXPAT REQUIRED)

else()
    message(STATUS "Using built-in expat code")
    # XML_STATIC is important to avoid sg_expat_external.h
    # declaring symbols as declspec(import)
    add_definitions(-DHAVE_EXPAT_CONFIG_H -DXML_STATIC)
    set(EXPAT_INCLUDE_DIRS 
	    ${PROJECT_SOURCE_DIR}/3rdparty/expat 
	    ${PROJECT_BINARY_DIR}/3rdparty/expat)
endif(SYSTEM_EXPAT)

include_directories(${EXPAT_INCLUDE_DIRS})

check_include_file(inttypes.h HAVE_INTTYPES_H)
check_include_file(sys/time.h HAVE_SYS_TIME_H)
check_include_file(sys/timeb.h HAVE_SYS_TIMEB_H)
check_include_file(unistd.h HAVE_UNISTD_H)
check_include_file(windows.h HAVE_WINDOWS_H)

if(HAVE_INTTYPES_H)
  # ShivaVG needs inttypes.h
  add_definitions(-DHAVE_INTTYPES_H)
endif()

if(ENABLE_RTI)
    # See if we have any rti library variant installed
    message(STATUS "RTI: ENABLED")
    find_package(RTI)
else()
    message(STATUS "RTI: DISABLED")
endif(ENABLE_RTI)

check_function_exists(gettimeofday HAVE_GETTIMEOFDAY)
check_function_exists(ftime HAVE_FTIME)
check_function_exists(timegm HAVE_TIMEGM)
check_function_exists(rint HAVE_RINT)
check_function_exists(mkdtemp HAVE_MKDTEMP)
check_function_exists(bcopy HAVE_BCOPY)
check_function_exists(mmap HAVE_MMAP)

if(HAVE_UNISTD_H)
    set(CMAKE_REQUIRED_INCLUDES ${CMAKE_INCLUDE_PATH})
    check_cxx_source_compiles(
       "#include <unistd.h>
        #if !defined(_POSIX_TIMERS) || (0 >= _POSIX_TIMERS)
            #error clock_gettime is not supported
        #endif

        int main() { return 0; }
        "
        HAVE_CLOCK_GETTIME)
endif(HAVE_UNISTD_H)

set(RT_LIBRARY "")
if(HAVE_CLOCK_GETTIME)
    check_library_exists(rt clock_gettime "" HAVE_RT)
    if(HAVE_RT)
        set(RT_LIBRARY rt)
    endif(HAVE_RT)
endif(HAVE_CLOCK_GETTIME)

set(DL_LIBRARY "")
check_cxx_source_compiles(
    "#include <dlfcn.h>
    int main(void) {
        return 0;
    }
    "
    HAVE_DLFCN_H)

if(HAVE_DLFCN_H)
    check_library_exists(dl dlerror "" HAVE_DL)
    set(DL_LIBRARY "dl")
endif()

SET(CMAKE_DEBUG_POSTFIX "d" CACHE STRING "add a postfix, usually 'd' on windows")
SET(CMAKE_RELEASE_POSTFIX "" CACHE STRING "add a postfix, usually empty on windows")
SET(CMAKE_RELWITHDEBINFO_POSTFIX "" CACHE STRING "add a postfix, usually empty on windows")
SET(CMAKE_MINSIZEREL_POSTFIX "" CACHE STRING "add a postfix, usually empty on windows")

# isnan might not be real symbol, so can't check using function_exists
check_cxx_source_compiles(
    "#include <cmath> 
    void f() { isnan(0.0);} "
    HAVE_ISNAN)

check_cxx_source_compiles(
    "#include <cmath> 
    void f() { std::isnan(0.0);} "
    HAVE_STD_ISNAN)

if(CMAKE_COMPILER_IS_GNUCXX)
    set(WARNING_FLAGS_CXX "-Wall")
    set(WARNING_FLAGS_C   "-Wall")

    # certain GCC versions don't provide the atomic builds, and hence
    # require is to provide them in SGAtomic.cxx
    set(CMAKE_REQUIRED_INCLUDES ${CMAKE_INCLUDE_PATH})
    check_cxx_source_compiles(
       "int main() { unsigned mValue; return __sync_add_and_fetch(&mValue, 1); }"
        GCC_ATOMIC_BUILTINS_FOUND)
endif(CMAKE_COMPILER_IS_GNUCXX)

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
   set(WARNING_FLAGS_CXX "-Wall -Wno-overloaded-virtual")
   set(WARNING_FLAGS_C   "-Wall")
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
# boost goes haywire wrt static asserts
    check_cxx_compiler_flag(-Wno-unused-local-typedefs HAS_NOWARN_UNUSED_TYPEDEFS)
    if(HAS_NOWARN_UNUSED_TYPEDEFS)
        set(WARNING_FLAGS_CXX " ${WARNING_FLAGS_CXX} -Wno-unused-local-typedefs")
    endif()
endif()

if(WIN32)

    if(MINGW)
        add_definitions(-D_WIN32_WINNT=0x501)
    endif()

=== 3rdparty/CMakeLists.txt ===
if (NOT SYSTEM_EXPAT)
	add_subdirectory(expat)
endif()

=== simgear/CMakeLists.txt ===

file(WRITE ${PROJECT_BINARY_DIR}/simgear/version.h "#define SIMGEAR_VERSION ${SIMGEAR_VERSION}")

foreach( mylibfolder 
        bucket
        bvh
        debug
        ephemeris
        io
        magvar
        math
        misc
        nasal
        nasal/cppbind
        props
        serial
        structure
        threads
        timing
        xml
        package
    )

    add_subdirectory(${mylibfolder})

endforeach( mylibfolder )

if(NOT SIMGEAR_HEADLESS)
    add_subdirectory(canvas)
    add_subdirectory(environment)
    add_subdirectory(screen)
    add_subdirectory(scene)
    add_subdirectory(sound)
endif(NOT SIMGEAR_HEADLESS)


if(ENABLE_RTI)
    add_subdirectory(hla)
endif(ENABLE_RTI)


set(HEADERS compiler.h constants.h sg_inlines.h ${PROJECT_BINARY_DIR}/simgear/version.h)
install (FILES ${HEADERS}  DESTINATION include/simgear/)

get_property(coreSources GLOBAL PROPERTY CORE_SOURCES)
get_property(sceneSources GLOBAL PROPERTY SCENE_SOURCES)
get_property(publicHeaders GLOBAL PROPERTY PUBLIC_HEADERS)
get_property(localExpatSources GLOBAL PROPERTY LOCAL_EXPAT_SOURCES)

if(SIMGEAR_SHARED)
    message(STATUS "Library building mode: SHARED LIBRARIES")
    add_library(SimGearCore SHARED ${coreSources} ${localExpatSources})

    set_property(TARGET SimGearCore PROPERTY LINKER_LANGUAGE CXX)
    set_property(TARGET SimGearCore PROPERTY VERSION   ${SIMGEAR_VERSION})
    set_property(TARGET SimGearCore PROPERTY SOVERSION ${SIMGEAR_SOVERSION})
    install(TARGETS SimGearCore EXPORT SimGearCoreConfig LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
    install(EXPORT SimGearCoreConfig DESTINATION share/SimGearCore)
    
    if(NOT SIMGEAR_HEADLESS)
        add_library(SimGearScene SHARED ${sceneSources})
        set_property(TARGET SimGearScene PROPERTY LINKER_LANGUAGE CXX)
        set_property(TARGET SimGearScene PROPERTY VERSION   ${SIMGEAR_VERSION})
        set_property(TARGET SimGearScene PROPERTY SOVERSION ${SIMGEAR_SOVERSION})

        # EXPORT SimGearSceneConfig
        install(TARGETS SimGearScene LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} )
    #    install(EXPORT SimGearSceneConfig DESTINATION share/SimGearScene)
    endif()
    
else()
    message(STATUS "Library building mode: STATIC LIBRARIES")

	get_property(FG_GROUPS_CORE_SOURCES_C GLOBAL PROPERTY FG_GROUPS_CORE_SOURCES_C)
	string(REPLACE "@" ";" groups ${FG_GROUPS_CORE_SOURCES_C} )
	foreach(g ${groups})
		string(REPLACE "#" ";" g2 ${g})
		list(GET g2 0 name)
		list(REMOVE_AT g2 0)
		source_group("${name}\\Sources" FILES ${g2})
	endforeach()

	get_property(FG_GROUPS_CORE_SOURCES_H GLOBAL PROPERTY FG_GROUPS_CORE_SOURCES_H)
	string(REPLACE "@" ";" groups ${FG_GROUPS_CORE_SOURCES_H} )
	foreach(g ${groups})
		string(REPLACE "#" ";" g2 ${g})
		list(GET g2 0 name)
		list(REMOVE_AT g2 0)
		source_group("${name}\\Headers" FILES ${g2})
	endforeach()

    add_library(SimGearCore STATIC ${coreSources} ${localExpatSources})
    install(TARGETS SimGearCore ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
    
    if(NOT SIMGEAR_HEADLESS)
		get_property(FG_GROUPS_SCENE_SOURCES_C GLOBAL PROPERTY FG_GROUPS_SCENE_SOURCES_C)
		string(REPLACE "@" ";" groups ${FG_GROUPS_SCENE_SOURCES_C} )
		foreach(g ${groups})
			string(REPLACE "#" ";" g2 ${g})
			list(GET g2 0 name)
			list(REMOVE_AT g2 0)
			source_group("${name}\\Sources" FILES ${g2})
		endforeach()

		get_property(FG_GROUPS_SCENE_SOURCES_H GLOBAL PROPERTY FG_GROUPS_SCENE_SOURCES_H)
		string(REPLACE "@" ";" groups ${FG_GROUPS_SCENE_SOURCES_H} )
		foreach(g ${groups})
			string(REPLACE "#" ";" g2 ${g})
			list(GET g2 0 name)
			list(REMOVE_AT g2 0)
			source_group("${name}\\Headers" FILES ${g2})
		endforeach()

        add_library(SimGearScene STATIC ${sceneSources})
        install(TARGETS SimGearScene ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
    endif(NOT SIMGEAR_HEADLESS)
endif(SIMGEAR_SHARED)

target_link_libraries(SimGearCore
    ${ZLIB_LIBRARY}
    ${RT_LIBRARY}
    ${DL_LIBRARY}
    ${EXPAT_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}
    ${CORE_SERVICES_LIBRARY})

if(NOT SIMGEAR_HEADLESS)
    target_link_libraries(SimGearScene
        SimGearCore
        ${ZLIB_LIBRARY}
        ${OPENSCENEGRAPH_LIBRARIES}
        ${OPENAL_LIBRARY}
        ${OPENGL_LIBRARY}
        ${JPEG_LIBRARY})
endif()

if(ENABLE_RTI)
    # Ugly first aid to make hla compile agian
    set_property(SOURCE hla/RTI13InteractionClass.cxx hla/RTI13ObjectClass.cxx
        hla/RTI13ObjectInstance.cxx hla/RTI13Federate.cxx
        hla/RTI13FederateFactory.cxx
        APPEND PROPERTY COMPILE_FLAGS "-I${RTI_INCLUDE_DIR}")
endif(ENABLE_RTI)

=== simgear/bucket/CMakeLists.txt ===

include (SimGearComponent)

set(HEADERS newbucket.hxx)
set(SOURCES newbucket.cxx)

simgear_component(bucket bucket "${SOURCES}" "${HEADERS}")

=== simgear/canvas/CMakeLists.txt ===
include (SimGearComponent)

set(HEADERS
  canvas_fwd.hxx
  Canvas.hxx
  CanvasEvent.hxx
  CanvasEventManager.hxx
  CanvasEventTypes.hxx
  CanvasEventVisitor.hxx
  CanvasMgr.hxx
  CanvasObjectPlacement.hxx
  CanvasPlacement.hxx
  CanvasSystemAdapter.hxx
  MouseEvent.hxx
  ODGauge.hxx
  VGInitOperation.hxx
)

set(SOURCES
  Canvas.cxx
  CanvasEvent.cxx
  CanvasEventManager.cxx
  CanvasEventVisitor.cxx
  CanvasMgr.cxx
  CanvasObjectPlacement.cxx
  CanvasPlacement.cxx
  ODGauge.cxx
  VGInitOperation.cxx
)

add_subdirectory(ShivaVG/src)
add_subdirectory(elements)

simgear_scene_component(canvas canvas "${SOURCES}" "${HEADERS}")

=== simgear/misc/CMakeLists.txt ===

include (SimGearComponent)

set(HEADERS 
    CSSBorder.hxx
    ListDiff.hxx
    ResourceManager.hxx
    interpolator.hxx
    make_new.hxx
    sg_dir.hxx
    sg_path.hxx
    sgstream.hxx
    stdint.hxx
    stopwatch.hxx
    strutils.hxx
    tabbed_values.hxx
    texcoord.hxx
    zfstream.hxx
    gzcontainerfile.hxx
    )

set(SOURCES
    CSSBorder.cxx
    ResourceManager.cxx
    interpolator.cxx
    sg_dir.cxx
    sg_path.cxx
    sgstream.cxx
    strutils.cxx
    tabbed_values.cxx
    texcoord.cxx
    zfstream.cxx
    gzcontainerfile.cxx
    )

simgear_component(misc misc "${SOURCES}" "${HEADERS}")

if(ENABLE_TESTS)

add_executable(test_CSSBorder CSSBorder_test.cxx)
add_test(CSSBorder ${EXECUTABLE_OUTPUT_PATH}/test_CSSBorder)
target_link_libraries(test_CSSBorder ${TEST_LIBS})

add_executable(test_tabbed_values tabbed_values_test.cxx)
add_test(tabbed_values ${EXECUTABLE_OUTPUT_PATH}/test_tabbed_values)
target_link_libraries(test_tabbed_values ${TEST_LIBS})

add_executable(test_strings strutils_test.cxx )
add_test(strings ${EXECUTABLE_OUTPUT_PATH}/test_strings)
target_link_libraries(test_strings ${TEST_LIBS})

add_executable(test_streams sgstream_test.cxx )
add_test(streams ${EXECUTABLE_OUTPUT_PATH}/test_streams)
target_link_libraries(test_streams ${TEST_LIBS})

add_executable(test_path path_test.cxx )
add_test(path ${EXECUTABLE_OUTPUT_PATH}/test_path)
target_link_libraries(test_path ${TEST_LIBS})

endif(ENABLE_TESTS)

=== simgear/nasal/CMakeLists.txt ===

include (SimGearComponent)

set(HEADERS 
    naref.h
    nasal.h
    )

set(SOURCES 
    bitslib.c
    code.c
    codegen.c
    gc.c
    hash.c
    iolib.c
    lex.c
    lib.c
    mathlib.c
    misc.c
    parse.c
    string.c
    thread-posix.c
    thread-win32.c
    threadlib.c
    utf8lib.c
    vector.c
    code.h
    data.h
    iolib.h
    parse.h
    )

simgear_component(nasal nasal "${SOURCES}" "${HEADERS}")

=== simgear/package/CMakeLists.txt ===

include (SimGearComponent)

set(HEADERS 
    Catalog.hxx
    Package.hxx
    Install.hxx
    Root.hxx
    Delegate.hxx
    )

set(SOURCES 
    Catalog.cxx
    Package.cxx
    Install.cxx
    Root.cxx
# internal helpers
    md5.c md5.h
    ioapi.c ioapi_mem.c ioapi.h
    unzip.h unzip.c
    )

simgear_component(package package "${SOURCES}" "${HEADERS}")

if(ENABLE_PKGUTIL)
  add_executable(sg_pkgutil pkgutil.cxx)
  target_link_libraries(sg_pkgutil ${TEST_LIBS})
endif()

=== simgear/props/CMakeLists.txt ===

include (SimGearComponent)

set(HEADERS 
    AtomicChangeListener.hxx
    condition.hxx
    easing_functions.hxx
    ExtendedPropertyAdapter.hxx
    PropertyBasedElement.hxx
    PropertyBasedMgr.hxx
    PropertyInterpolationMgr.hxx
    PropertyInterpolator.hxx
    propertyObject.hxx
    props.hxx
    props_io.hxx
    propsfwd.hxx
    tiedpropertylist.hxx
    vectorPropTemplates.hxx
    )

set(SOURCES 
    AtomicChangeListener.cxx
    condition.cxx
    easing_functions.cxx
    PropertyBasedElement.cxx
    PropertyBasedMgr.cxx
    PropertyInterpolationMgr.cxx
    PropertyInterpolator.cxx
    propertyObject.cxx
    props.cxx
    props_io.cxx
    )

simgear_component(props props "${SOURCES}" "${HEADERS}")

if(ENABLE_TESTS)

add_executable(test_props props_test.cxx)
target_link_libraries(test_props ${TEST_LIBS})
add_test(props ${EXECUTABLE_OUTPUT_PATH}/test_props)

add_executable(test_propertyObject propertyObject_test.cxx)
target_link_libraries(test_propertyObject ${TEST_LIBS})
add_test(propertyObject ${EXECUTABLE_OUTPUT_PATH}/test_propertyObject)

add_executable(test_easing_functions easing_functions_test.cxx)
target_link_libraries(test_easing_functions ${TEST_LIBS})
add_test(easing_functions ${EXECUTABLE_OUTPUT_PATH}/test_easing_functions)

endif(ENABLE_TESTS)

=== simgear/scene/CMakeLists.txt ===
include (SimGearComponent)

include_directories(${PROJECT_SOURCE_DIR})

foreach( mylibfolder 
        material
        model
        sky
        tgdb
        util
        tsync
    )

    add_subdirectory(${mylibfolder})

endforeach( mylibfolder )

=== simgear/screen/CMakeLists.txt ===
include (SimGearComponent)

set(HEADERS 
    colors.hxx
    extensions.hxx
    screen-dump.hxx
	tr.h
    )


set(SOURCES 
    extensions.cxx
    screen-dump.cxx
	tr.cxx
    )

if(JPEG_FACTORY)
    list(APPEND HEADERS jpgfactory.hxx)
    list(APPEND SOURCES jpgfactory.cxx)
endif()


simgear_scene_component(screen screen "${SOURCES}" "${HEADERS}")

=== simgear/sound/CMakeLists.txt ===
include (SimGearComponent)

set(HEADERS 
    sample_group.hxx
    sample_openal.hxx
    sample_queue.hxx
    soundmgr_openal.hxx
    xmlsound.hxx
    readwav.hxx
    )
    
set(SOURCES 
    sample_group.cxx
    sample_openal.cxx
    sample_queue.cxx
    soundmgr_openal.cxx
    xmlsound.cxx
    readwav.cxx
    soundmgr_openal_private.hxx
    )

simgear_scene_component(sound sound "${SOURCES}" "${HEADERS}")

if(ENABLE_TESTS AND ENABLE_SOUND)

if (SIMGEAR_SHARED)
    set( SOUND_TEST_LIBS
        ${TEST_LIBS})
else()
    set(SOUND_TEST_LIBS
        ${TEST_LIBS}
        ${OPENAL_LIBRARY})
endif()

function(create_test TEST_NAME)
    add_executable(${TEST_NAME} ${TEST_NAME}.cxx)
    target_link_libraries(${TEST_NAME} ${SOUND_TEST_LIBS})
    set_target_properties(${TEST_NAME} PROPERTIES
            COMPILE_DEFINITIONS "SRC_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}\"" )
endfunction()
    
create_test(openal_test1)
create_test(openal_test2)
create_test(openal_test3)
create_test(openal_test4)
endif()

=== debian/changelog ===
simgear (3.0.0-6) unstable; urgency=medium

  * Add kfreebsd.patch. Closes: #765818.
  * Bump S-V: no changes required.

 -- Markus Wanner <markus@bluegap.ch>  Thu, 23 Oct 2014 11:37:25 +0200

simgear (3.0.0-5) unstable; urgency=medium

  * Simplify libjpeg dependency. Closes: #763493.
  * Add patch naref_endianness.patch to fix build on arm64.
    Closes: #761203.

 -- Markus Wanner <markus@bluegap.ch>  Tue, 07 Oct 2014 09:53:01 +0200

simgear (3.0.0-4) unstable; urgency=low

  * Add patch invalid-utf8.patch. Closes: #750859.

 -- Markus Wanner <markus@bluegap.ch>  Wed, 11 Jun 2014 18:17:10 +0200

simgear (3.0.0-3) unstable; urgency=low

  * Drop the BSD-with-advertising-clause from debian/copyright - upstream
    removed the files for the 3.0 release. Closes: #737733.

 -- Markus Wanner <markus@bluegap.ch>  Mon, 07 Apr 2014 19:01:15 +0200

simgear (3.0.0-2) unstable; urgency=medium

  * Recompile for openscenegraph in sid.

 -- Markus Wanner <markus@bluegap.ch>  Thu, 20 Feb 2014 18:05:27 +0100

simgear (3.0.0-1) unstable; urgency=medium

  [ Markus Wanner ]
  * New upstream release.
  * Drop the md5 replacement patch - applied upstream.
  * Adjust watchfile to properly account for release candidates.

  [ Rebecca Palmer ]
  * Replace sgstream_ignore_write_error.patch with a real fix in
    sgstream_test_fix_length.patch and respect test suite results, again.

 -- Markus Wanner <markus@bluegap.ch>  Wed, 19 Feb 2014 08:35:13 -0800

simgear (3.0.0~git20140204+c99ea4-1) unstable; urgency=low

  [ Markus Wanner ]
  * New intermediate snapshot pre 3.0.0.
  * Update debian/copyright. (Doesn't quite close #737733, though).
  * Temporarily ignore test suite failures to unblock the openscenegraph
    transition.
  * Add a patch to replace the given md5 implementation.

  [ Rebecca Palmer ]
  * Don't fail stream test if unable to set up test file.
  * Enable verbose test output.

 -- Markus Wanner <markus@bluegap.ch>  Thu, 06 Feb 2014 21:19:24 +0100

simgear (3.0.0~git20140123+f16c99-1) unstable; urgency=low

  * New upstream release.
  * Automate adjustment of .install and .shlibs via clean target in
    debian/rules.
  * Bump Standards-Version to 3.9.5; no changes needed.
  * Drop patch cppbind-charsignedness.diff, it got applied upstream.
  * Drop the libsvn-dev dependency, simgear now provides its own svn
    client.

 -- Markus Wanner <markus@bluegap.ch>  Wed, 22 Jan 2014 22:48:02 +0100

simgear (2.12.0-1) experimental; urgency=low

  * New upstream release.
  * Adjust .install and .shlibs files accordingly.
  * Drop patches gcc-macro-correction.diff, osg-compat.diff,
    CVE-2012-2090.diff CVE-2012-2091.diff. These got applied upstream.

 -- Markus Wanner <markus@bluegap.ch>  Sun, 22 Sep 2013 21:15:48 +0200

=== debian/control ===
Source: simgear
Section: libs
Priority: extra
Maintainer: Debian FlightGear Crew <pkg-fgfs-crew@lists.alioth.debian.org>
Uploaders: Ove Kaaven <ovek@arcticnet.no>,
 Markus Wanner <markus@bluegap.ch>
Build-Depends: debhelper (>= 8.1.3), libx11-dev, libxext-dev, libxi-dev,
 libice-dev, libsm-dev, libxt-dev, libxmu-dev, zlib1g-dev, libboost-dev,
 libopenal-dev, libalut-dev, libexpat1-dev, cmake (>= 2.6),
 libgl1-mesa-dev | libgl-dev,
 libglu1-mesa-dev | libglu-dev,
 freeglut3-dev | libglut3-dev,
 libjpeg-dev,
 libopenscenegraph-dev (>> 3.0.0)
Standards-Version: 3.9.6
Homepage: http://www.simgear.org/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/simgear.git
Vcs-Git: git://anonscm.debian.org/collab-maint/simgear.git

Package: libsimgearcore3.0.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: simgear0
Description: Simulator Construction Gear -- core library
 SimGear is a collection of libraries useful for constructing
 simulation and visualization applications such as FlightGear
 or TerraGear.
 .
 This package contains the core library.

Package: libsimgearcore3.0.0-dbg
Architecture: any
Section: debug
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libsimgearcore3.0.0 (= ${binary:Version}),
 ${misc:Depends}
Description: debugging symbols for libsimgearcore
 SimGear is a collection of libraries useful for constructing
 simulation and visualization applications such as FlightGear
 or TerraGear.
 .
 This package contains the debug symbols for the core library.

Package: libsimgearscene3.0.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libsimgearcore3.0.0 (= ${binary:Version}),
 ${shlibs:Depends}, ${misc:Depends}
Conflicts: simgear0
Description: Simulator Construction Gear -- scene library
 SimGear is a collection of libraries useful for constructing
 simulation and visualization applications such as FlightGear
 or TerraGear.
 .
 This package contains the scene library.

Package: libsimgearscene3.0.0-dbg
Architecture: any
Section: debug
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libsimgearcore3.0.0 (= ${binary:Version}),
 ${misc:Depends}
Conflicts: simgear0
Description: debugging symbols for libsimgearscene
 SimGear is a collection of libraries useful for constructing
 simulation and visualization applications such as FlightGear
 or TerraGear.
 .
 This package contains the debug symbols for the scene library.

Package: libsimgear-dev
Architecture: any
Section: libdevel
Depends: libsimgearcore3.0.0 (= ${binary:Version}),
 libsimgearscene3.0.0 (= ${binary:Version}),
 libopenscenegraph-dev, libc6-dev, ${misc:Depends}
Replaces: simgear-dev (<< 2.10.0~)
Breaks: simgear-dev (<< 2.10.0~)
Description: Simulator Construction Gear -- development files
 SimGear is a collection of libraries useful for constructing
 simulation and visualization applications such as FlightGear
 or TerraGear.
 .
 This package contains the headers and static libraries.

Package: simgear-dev
Depends: libsimgear-dev, ${misc:Depends}
Architecture: all
Section: oldlibs
Description: transitional dummy package
 This is a transitional dummy package. It can safely be removed.

=== debian/watch ===
version=3
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)\d*)$/$1~$2/ \
 ftp://mirrors.ibiblio.org/pub/mirrors/simgear/ftp/Source/simgear-(.*)\.tar\.bz2
